#!/usr/bin/env perl

use strict;
use warnings;
use GD;

my $width = 200;
my $height = 80;
my $font_size = 24;
my $font = '/usr/local/etc/ejabberd/captcha/flashit.ttf';

my $str = 'error';
$str = $ARGV[0] if ($#ARGV >= 0);

my $image = new GD::Image($width, $height, 1) || die;
$image->saveAlpha(1);
my $bg = $image->colorAllocateAlpha(0, 0, 0, 127);
$image->fill(0, 0, $bg);

my $caplen = length($str);
for (my $i = 0; $i < $caplen; $i++){
	my ($x, $y, $mid, $color, $angle);

  $x = ($width - 20) / $caplen * $i + 10;
  $x = $x + int(rand(4));

	$mid = ($height - $font_size) / 2;
  $y = $height - $mid + ($mid/2) - int(rand($mid));

  $color = $image->colorAllocate(
			int(rand(110)),
			int(rand(130)),
			int(rand(150))
		);
  $angle = (25 - int(rand(50))) * 3.14 / 180;
	$image->stringFT($color,
			$font,
			$font_size,
			$angle,
			$x, $y,
			substr($str, $i, 1)
		);
}

binmode(STDOUT);
print $image->png();

exit(0);

